﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

#if !SILVERLIGHT
namespace UIT.WPF.Renderers
#else
namespace UIT.Silverlight.Renderers
#endif
{
#if !SILVERLIGHT
    public abstract class WpfRenderer<T, U> : ControlRenderer<T>, IWpfRenderer<U>
#else
    public abstract class SlRenderer<T, U> : ControlRenderer<T>, ISlRenderer<U>
#endif
        where T : class, Controls.IControl
        where U : UIElement
    {
        public U Result
        {
            get;
            protected set;
        }

#if !SILVERLIGHT
        UIElement IWpfRenderer.Result
#else
        UIElement ISlRenderer.Result
#endif
        {
            get { return Result; }
        }
    }
}
