﻿using UIT.Web;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Xml;
using UIT;
using System.Text;
using UIT.Controls;
using UIT.Web.Renderers;

namespace UIT.Web.Test
{


    /// <summary>
    ///This is a test class for ButtonRendererTest and is intended
    ///to contain all ButtonRendererTest Unit Tests
    ///</summary>
    [TestClass()]
    public class ButtonRendererTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Render
        ///</summary>
        [TestMethod()]
        public void RenderTest()
        {
            StringBuilder sb = new StringBuilder();
            XmlWriter writer = XmlWriter.Create(sb, new XmlWriterSettings() { OmitXmlDeclaration = true });
            WebRendererManager manager = new WebRendererManager(writer);
            Button control = new Button() { Text = "Test" };
            IControlRenderer<Button> target = (IControlRenderer<Button>)manager.Manager.Control.GetRenderer<Button>(control);
            target.Initialize(manager.Manager, writer);
            target.Render(control);
            writer.Flush();
            Assert.AreEqual(@"<input type=""button"" value=""Test"" />", sb.ToString());
        }
    }
}
