﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Reflection;
using UIT.Animations;
using UIT.VisualStates;

namespace UIT
{
    public interface IUitContext
    {
        IStoryBoardManager Storyboard { get; }

        IVisualStateManager VisualState { get; }

        Application Application { get; }

        string Mode { get; }

        ISecurityContext Security { get; }

        RendererManager RendererManager { get; }

        bool IsAllowed(string resource, string verb);

        Stream GetStream(Uri uri);

        Uri ResolveUrl(Uri StartupUri);

        object this[string key] { get; set; }
    }
}
