﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace JQueryControlToolkit
{
    public interface JSObject
    {
        string ToScript();

        void ToScript(TextWriter toScript);
    }

    public class JSUndefined : JSObject
    {
        public override string ToString()
        {
            return "undefined";
        }

        #region JSObject Members

        public string ToScript()
        {
            return ToString();
        }

        public void ToScript(TextWriter toScript)
        {
            toScript.Write(ToScript());
        }

        #endregion
    }

    public class JSString : JSObject
    {
        string innerValue;

        public JSString(string innerValue)
        {
            this.innerValue = innerValue;
        }

        #region JSObject Members

        public string ToScript()
        {
            return Extensions.ToScript(this);
        }

        public void ToScript(TextWriter toScript)
        {
            toScript.Write(DomResult.Escape(innerValue));
        }

        #endregion

        public static implicit operator JSString(string s)
        {
            return new JSString(s);
        }
    }
}
